/**
 * Tooltip ([data-tooltip])
 */

$width: 180px;

[data-tooltip] {
  position: relative;

  // &:not(a):not(button):not(input) {
  //   border-bottom: 1px dotted;
  //   text-decoration: none;
  //   cursor: help;
  // }

  &::before {
    width: $width;
  }

  &::before,
  &::after {
    display: block;
    z-index: 99;
    position: absolute;
    bottom: 100%;
    left: 50%;
    padding: 0.25rem 0.5rem;
    overflow: hidden;
    transform: translate(-50%, -0.25rem);
    border-radius: var(--border-radius);
    background: var(--tooltip-background-color);
    content: attr(data-tooltip);
    color: var(--tooltip-color);
    font-style: normal;
    font-weight: var(--font-weight);
    font-size: 0.875rem;
    text-decoration: none;
    text-overflow: ellipsis;
    white-space: break-spaces;
    opacity: 0;
    pointer-events: none;
  }

  // Caret
  &::after {
    padding: 0;
    transform: translate(-50%, 0rem);
    border-top: 0.3rem solid;
    border-right: 0.3rem solid transparent;
    border-left: 0.3rem solid transparent;
    border-radius: 0;
    background-color: transparent;
    content: "";
    color: var(--tooltip-background-color);
  }

  // Display
  &:focus,
  &:hover {
    &::before,
    &::after {
      opacity: 1;
    }
  }

  // Animations, excluding touch devices
  @if $enable-transitions {
    @media (hover: hover) and (pointer: fine) {
      &:focus,
      &:hover {
        &::before,
        &::after {
          animation-duration: 0.2s;
          animation-name: slide;
        }

        &::after {
          animation-name: slideCaret;
        }
      }
    }
  }
}

// Animations
@if $enable-transitions {
  @keyframes slide {
    from {
      transform: translate(-50%, 0.75rem);
      opacity: 0;
    }
    to {
      transform: translate(-50%, -0.25rem);
      opacity: 1;
    }
  }

  @keyframes slideCaret {
    from {
      opacity: 0;
    }
    50% {
      transform: translate(-50%, -0.25rem);
      opacity: 0;
    }
    to {
      transform: translate(-50%, 0rem);
      opacity: 1;
    }
  }
}

[data-tooltip-down] {
  position: relative;

  // &:not(a):not(button):not(input) {
  //   border-bottom: 1px dotted;
  //   text-decoration: none;
  //   cursor: help;
  // }

  &::before {
    width: $width;
  }

  &::before,
  &::after {
    display: block;
    z-index: 99;
    position: absolute;
    top: 100%;
    left: 50%;
    padding: 0.25rem 0.5rem;
    overflow: hidden;
    transform: translate(-50%, 0.25rem);
    border-radius: var(--border-radius);
    background: var(--tooltip-background-color);
    content: attr(data-tooltip-down);
    color: var(--tooltip-color);
    font-style: normal;
    font-weight: var(--font-weight);
    font-size: 0.875rem;
    text-decoration: none;
    text-overflow: ellipsis;
    white-space: break-spaces;
    opacity: 0;
    pointer-events: none;
  }

  // Caret
  &::after {
    padding: 0;
    transform: translate(-50%, 0rem);
    border-bottom: 0.3rem solid;
    border-right: 0.3rem solid transparent;
    border-left: 0.3rem solid transparent;
    border-radius: 0;
    background-color: transparent;
    content: "";
    color: var(--tooltip-background-color);
  }

  // Display
  &:focus,
  &:hover {
    &::before,
    &::after {
      opacity: 1;
    }
  }

  // Animations, excluding touch devices
  @if $enable-transitions {
    @media (hover: hover) and (pointer: fine) {
      &:focus,
      &:hover {
        &::before,
        &::after {
          animation-duration: 0.2s;
          animation-name: slideDown;
        }

        &::after {
          animation-name: slideCaretDown;
        }
      }
    }
  }
}

// Animations
@if $enable-transitions {
  @keyframes slideDown {
    from {
      transform: translate(-50%, -0.75rem);
      opacity: 0;
    }
    to {
      transform: translate(-50%, 0.25rem);
      opacity: 1;
    }
  }

  @keyframes slideCaretDown {
    from {
      opacity: 0;
    }
    50% {
      transform: translate(-50%, 0.25rem);
      opacity: 0;
    }
    to {
      transform: translate(-50%, 0rem);
      opacity: 1;
    }
  }
}
